
        INCLUDE \masm32\include\masm32rt.inc

;########################################################################

DlgProc         PROTO :HWND,:UINT,:WPARAM,:LPARAM
KeyboardProc    PROTO :SDWORD,:WPARAM,:LPARAM

;########################################################################

IDD_DIALOG1     EQU 101
IDC_STC1        EQU 102
IDC_EDT1        EQU 103
IDC_EDT2        EQU 104
IDI_ICON        EQU 200

;########################################################################

        .DATA

InitFlag        dd 0
szTitle         db 'Caps Lock State Example',0
Message1        db 'Caps Lock is On',0
Message2        db 'Focus Changed',0

;************************************************************************

        .DATA?

hDlg            dd ?
hHook           dd ?
hEdit1          dd ?
hEdit2          dd ?
hInstance       dd ?
hIcon           dd ?
CapsState       dd ?
FocusHandle     dd ?

;########################################################################

        .CODE

DlgProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        mov     ecx,uMsg
	cmp     ecx,WM_KEYDOWN
        jz      dProc1

        cmp     ecx,WM_COMMAND
        jnz     dProc2

;-----------------------------------------

;WM_COMMAND

;wParam low word = control identifier
;wParam high word = notification code
;lParam = control handle

        movzx   ecx,word ptr wParam+2  ;convert lParam high word to dword
        cmp     ecx,EN_SETFOCUS
        jnz     dProc3

;WM_COMMAND:EN_SETFOCUS

        mov     edx,lParam
        cmp     edx,FocusHandle
        jz      dProc3

        mov     FocusHandle,edx

dProc0: mov     eax,CapsState
        or      eax,eax
        jz      dProc3

        INVOKE  MessageBox,NULL,ustr$(eax),offset Message2,MB_ICONINFORMATION
        jmp short dProc3

;-----------------------------------------

;WM_KEYDOWN (only sent by our hook)

dProc1: mov     eax,CapsState
        or      eax,eax
        jz      dProc3             ;CapsState = 0 when caps lock is off

        INVOKE  MessageBox,NULL,ustr$(eax),offset Message1,MB_ICONINFORMATION
        jmp short dProc3

;-----------------------------------------

dProc2: cmp     ecx,WM_SIZE
        jz      dProc4

        cmp     ecx,WM_INITDIALOG
        jz      dProc5

        cmp     ecx,WM_CLOSE
        jz      dProc6

dProc3: xor     eax,eax  
        ret

;-----------------------------------------

;WM_SIZE

;we use WM_SIZE to tell us when the dialog
;box has been displayed for the first time

dProc4: cmp     ecx,InitFlag
        jz      dProc3

        mov     InitFlag,ecx
        jmp     dProc0

;-----------------------------------------

;WM_INITDIALOG

dProc5: push    ebx
        mov     ebx,hWnd
        mov     hDlg,ebx                           ;initialize hDlg
        INVOKE  SetWindowText,ebx,offset szTitle
        INVOKE  SendMessage,ebx,WM_SETICON,ICON_SMALL,hIcon

;**********************************

;initialize CapsState variable

        INVOKE  GetKeyState,VK_CAPITAL
        and     eax,1
        mov     CapsState,eax

;insert keyboard hook

        INVOKE  GetCurrentThreadId
        INVOKE  SetWindowsHookEx,WH_KEYBOARD,KeyboardProc,NULL,eax
        mov     hHook,eax

;**********************************

        INVOKE  GetDlgItem,ebx,IDC_EDT1
        mov     hEdit1,eax
        mov     FocusHandle,eax                    ;initialize FocusHandle
        INVOKE  SetFocus,eax
        INVOKE  GetDlgItem,ebx,IDC_EDT2
        mov     hEdit2,eax
        pop     ebx
        jmp     dProc3

;-----------------------------------------

;WM_CLOSE

;**********************************

;remove keyboard hook

dProc6: INVOKE  UnhookWindowsHookEx,hHook

;**********************************

        INVOKE  EndDialog,hWnd,0
        jmp     dProc3

DlgProc ENDP

;************************************************************************

KeyboardProc PROC nCode:SDWORD,wParam:WPARAM,lParam:LPARAM

;keyboard hook proc - adapted from example code by MichaelW

        test byte ptr nCode+3,80h       ;if nCode is negative, call next hook
        jz      kProc1

        INVOKE  CallNextHookEx,hHook,nCode,wParam,lParam

kProc0: ret

kProc1: mov     eax,VK_CAPITAL
        cmp     eax,wParam              ;only caps lock key
        jnz     kProc0

        test byte ptr lParam+3,40h      ;only key down - not key up
        jnz     kProc0

        INVOKE  GetKeyState,eax
        and     eax,1                   ;"toggle state" bit only
        mov     CapsState,eax
        INVOKE  PostMessage,hDlg,WM_KEYDOWN,wParam,lParam
        jmp     kProc0

KeyboardProc ENDP

;************************************************************************

_main   PROC

        xor     edi,edi
        INVOKE  InitCommonControls
        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        INVOKE  LoadIcon,eax,IDI_ICON 
        mov     hIcon,eax
        INVOKE  DialogBoxParam,hInstance,IDD_DIALOG1,edi,DlgProc,edi
        INVOKE  ExitProcess,edi

_main   ENDP

;########################################################################

        END     _main

